
Redmine - Defect #30285

Microsoft SQL server support is broken

2018-12-28 01:34 - Go MAEDA

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Database Estimated time: 0.00 hour

Target version: 4.0.7   

Resolution: Fixed Affected version:  

Description

Redmine 4.0.0 does not work with Microsoft SQL Server.

One of the causes is that a dependent library activerecord-sqlserver-adapter does not support Rails 5.2 yet.

https://github.com/rails-sqlserver/activerecord-sqlserver-adapter/issues/636

Related issues:

Related to Redmine - Defect #30284: Internal Server Error When Deleting a User Closed

Related to Redmine - Defect #30211: Crash with the message "undefined method ... Closed

Related to Redmine - Defect #30210: Application crash when deleting an issue ... Closed

Related to Redmine - Feature #23630: Migrate to Rails 5.2 Closed

Related to Redmine - Defect #28506: Error Setup Redmine with Win10 Closed

Related to Redmine - Patch #31230: Fix: migration fails in MS SQL-Server Closed

Associated revisions

Revision 19628 - 2020-04-01 10:12 - Go MAEDA

Update tiny_tds to 1.0.5 and activecord-sqlserver-adapter to 5.2.1 (#30285).

Patch by Pavel Rosický.

Revision 19629 - 2020-04-01 10:43 - Go MAEDA

Merged r19628 from trunk to 4.1-stable (#30285).

Revision 19630 - 2020-04-01 10:44 - Go MAEDA

Merged r19628 from trunk to 4.0-stable (#30285).

History

#1 - 2018-12-28 01:35 - Go MAEDA

- Related to Defect #30284: Internal Server Error When Deleting a User added

#2 - 2018-12-28 01:36 - Go MAEDA

- Related to Defect #30211: Crash with the message "undefined method `alias_method_chain'" when connecting to Microsoft SQL Server added

#3 - 2018-12-28 01:36 - Go MAEDA

- Related to Defect #30210: Application crash when deleting an issue from issue list with SQLServer added

#4 - 2018-12-28 01:37 - Go MAEDA

- Related to Feature #23630: Migrate to Rails 5.2 added

#5 - 2018-12-28 03:18 - Go MAEDA

- Subject changed from Microsoft SQL server is broken to Microsoft SQL server support is broken

#6 - 2019-01-20 07:46 - Jean-Philippe Lang

- Target version changed from 4.0.1 to 4.0.2
#7 - 2019-02-13 09:41 - Go MAEDA

activerecord-sqlserver-adapter 5.2.0.rc1 has been released on February 12.

#8 - 2019-02-21 17:20 - Jean-Philippe Lang

- Target version changed from 4.0.2 to Candidate for next minor release

Waiting for final release of activerecord-sqlserver-adapter 5.2.0

#9 - 2019-03-05 22:17 - Marius BĂLTEANU

- Related to Defect #28506: Error Setup Redmine with Win10 added

#10 - 2019-03-05 22:17 - Marius BĂLTEANU

- Related to deleted (Defect #28506: Error Setup Redmine with Win10)

#11 - 2019-03-05 22:22 - Marius BĂLTEANU

- Related to Defect #28506: Error Setup Redmine with Win10 added

#12 - 2019-03-20 03:10 - Go MAEDA

activerecord-sqlserver-adapter 5.2.0 has been released on March 19.

https://github.com/rails-sqlserver/activerecord-sqlserver-adapter/blob/master/CHANGELOG.md#v520

Can anyone test if Redmine 4.0 works with MS SQL Server? Please note that you have to run bundle update to install the latest

activerecord-sqlserver-adapter gem.

#13 - 2019-03-20 03:25 - sebastián scarano

yeap, here's the release, it would be great if redmine latest version could be confirmed to work ok with sql server...

and update the note at http://www.redmine.org/projects/redmine/wiki/RedmineInstall#Supported-database-back-ends

Redmine 4.0 does not support SQL Server as of December 2018 because a dependent library activerecord-sqlserver-adapter does not support

Rails 5.2 yet.

#14 - 2019-03-20 23:32 - Pavel Rosický

I tested it on SQL Server 2017 with these gems

activerecord-sqlserver-adapter (5.2.0)

tiny_tds (2.1.2-x64-mingw32)

it passes all tests, but unfortunatelly there's a problem with migrations due to this bug

https://github.com/rails-sqlserver/activerecord-sqlserver-adapter/pull/691

TinyTds::Error: The object 'DF_projects_description' is dependent on column 'description'.

087_change_projects_description_to_text.rb:5:in `up'

 there might be an option to add a workaround in redmine, but it won't be pretty, so I would prefer to fix the problem in activerecord-sqlserver-adapter.

#15 - 2019-04-23 17:27 - John Bolthouse

Is there any progress on this? I would definitely like to upvote this as I have clients on Sql Server. I would also be happy to test potential solutions in

our dev environments.

#16 - 2019-04-23 21:10 - Pavel Rosický

sorry, no feedback from activerecord-sqlserver-adapter's maintainers yet

but you can test my (unofficial) patch by changing the Gemfile

  when /sqlserver/

    gem "tiny_tds", "2.1.2", :platforms => [:mri, :mingw, :x64_mingw]

    gem "activerecord-sqlserver-adapter", :git => 'https://github.com/ahorek/activerecord-sqlserver-adapter.gi

t', :branch => 'constrains_bug', :platforms => [:mri, :mingw, :x64_mingw]

 on my environment it passes all activerecord-sqlserver-adapter's tests and redmine's tests. Let us know if it works for you.
#17 - 2019-06-11 21:47 - Pavel Rosický

- File sqlserver.patch added

if you're still interested, here's a patch for redmine

#18 - 2019-06-12 21:02 - Ricidleiv Tondatto

Pavel Rosický wrote:

if you're still interested, here's a patch for redmine

 For those who like me had to search how to apply this patch, here the official Redmine's way.

http://www.redmine.org/projects/redmine/wiki/patch

#19 - 2019-07-12 14:12 - Alexander Ryabinovskiy

Pavel Rosický wrote:

sorry, no feedback from activerecord-sqlserver-adapter's maintainers yet

but you can test my (unofficial) patch by changing the Gemfile

[...]

on my environment it passes all activerecord-sqlserver-adapter's tests and redmine's tests. Let us know if it works for you.

 Hello. They have megred your issue, as I can see?

https://github.com/ahorek/activerecord-sqlserver-adapter.git

Is this problem solved?

#20 - 2019-07-16 10:56 - Hiep Le

- File patchCygwin.jpg added

Hi Pavel,

Thanks for the update. Probably the problem not yet solved.

Could you please help clarify clearer with the patch file?

In Cygwin, I tried using both $ patch -p0 -i sqlserver.patch and $ patch -p0 < sqlserver.patch and none of them work.

Before using patch command, I converted the file using unix2dos but no luck. It kept failing with the LF and CRLF issue for ending line between linux

and windows during file conversion.

Do I need to convert the file and what is the proper way to do? Please see the attached image.

 patchCygwin.jpg 

Thank you very much!

Hiep

#21 - 2019-07-16 12:26 - Pavel Rosický

Hiep Le

ok, try to change the Gemfile instead.

  when /sqlserver/

    gem "tiny_tds", "2.1.2", :platforms => [:mri, :mingw, :x64_mingw]

    gem "activerecord-sqlserver-adapter", :git => 'https://github.com/ahorek/activerecord-sqlserver-adapter.gi

t', :branch => 'constrains_bug', :platforms => [:mri, :mingw, :x64_mingw]

 CR/LF issues is off-topic, please ask on forums if you need help

there're better alternatives than cygwin

https://rubyinstaller.org/downloads/ or https://en.wikipedia.org/wiki/Windows_Subsystem_for_Linux

Alexander Ryabinovskiy

Hello. They have megred your issue, as I can see?

https://github.com/ahorek/activerecord-sqlserver-adapter.git

Is this problem solved?

yes, it's merged, but there's no release yet. https://github.com/rails-sqlserver/activerecord-sqlserver-adapter/releases
until that happens www.redmine.org/attachments/download/23286/sqlserver.patch might be a temporarly solution. cc Go MAEDA, your opinion?

#22 - 2020-02-15 06:16 - Bob Binary

Go MAEDA wrote:

Redmine 4.0.0 does not work with Microsoft SQL Server.

One of the causes is that a dependent library activerecord-sqlserver-adapter does not support Rails 5.2 yet.

 Hi,

any news about this? I would like to use the latest version of redmine with mssql on windows. As far as I understand the answers in this thread do not

solve the problem and currently there is no way to get the latest version of redmine running on mssql?

BR,

Bob

#23 - 2020-02-15 11:00 - Pavel Rosický

As far as I understand the answers in this thread do not solve the problem and currently there is no way to get the latest version of redmine running

on mssql?

officially no, by using an unofficial patch yes. (https://www.redmine.org/issues/30285#note-16)

I'm not the maintainer of the https://github.com/rails-sqlserver/activerecord-sqlserver-adapter gem, so there's nothing more I can do. The current state

of development seems to be pretty dead.

#24 - 2020-03-31 16:39 - Pavel Rosický

- File Gemfile.patch added

activerecord-sqlserver-adapter 5.2.1 has been released on 31.3.2020. We should update the Gemfile.

#25 - 2020-03-31 16:54 - Marius BĂLTEANU

- Target version changed from Candidate for next minor release to 4.1.1

#26 - 2020-03-31 17:43 - Bob Binary

Great! When will 4.1.1 be released?

#27 - 2020-04-01 09:49 - Yuichi HARADA

Pavel Rosický wrote:

activerecord-sqlserver-adapter 5.2.1 has been released on 31.3.2020. We should update the Gemfile.

 +1

I think it's good. I confirmed using the Docker image "mcr.microsoft.com/mssql/server:2017-latest-ubuntu".

#28 - 2020-04-01 10:19 - Go MAEDA

- Status changed from New to Resolved

- Assignee set to Go MAEDA

- Resolution set to Fixed

Pavel Rosický wrote:

activerecord-sqlserver-adapter 5.2.1 has been released on 31.3.2020. We should update the Gemfile.

 Committed the patch. Thank you for working hard on fixing activerecord-sqlserver-adapter.

Marius, I think we can apply the patch to 4.0-stable as well as 4.1-stable, what do you think? SQL Server support is broken in Redmine 4.0 and later.

#29 - 2020-04-01 10:35 - Marius BĂLTEANU

- Target version changed from 4.1.1 to 4.0.7

Go MAEDA wrote:
Pavel Rosický wrote:

activerecord-sqlserver-adapter 5.2.1 has been released on 31.3.2020. We should update the Gemfile.

 Committed the patch. Thank you for working hard on fixing activerecord-sqlserver-adapter.

Marius, I think we can apply the patch to 4.0-stable as well as 4.1-stable, what do you think? SQL Server support is broken in Redmine 4.0 and

later.

 Sure, good idea. I don't know why I thought that only 4.1 is affected.

#30 - 2020-04-01 10:46 - Go MAEDA

- Status changed from Resolved to Closed

Merged r19628 to stable branches.

#31 - 2020-04-04 04:37 - Go MAEDA

- Related to Patch #31230: Fix: migration fails in MS SQL-Server added

Files

sqlserver.patch 4.55 KB 2019-06-11 Pavel Rosický

patchCygwin.jpg 399 KB 2019-07-16 Hiep Le

Gemfile.patch 786 Bytes 2020-03-31 Pavel Rosický
